//+------------------------------------------------------------------+
//|                                           Awesome 4 color v1.mq4 |
//|                      originalAwesome 4 color modfications by cja |
//|                      modified for alerts by mrtools              |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  LimeGreen
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Maroon
#property  indicator_width1  4
#property  indicator_width2  4
#property  indicator_width3  4
#property  indicator_width4  4

//
//
//
//
//

extern int    MaMethod1         = MODE_SMA;
extern int    MaPeriod1         = 5;
extern int    MaPrice1          = PRICE_MEDIAN;
extern int    MaMethod2         = MODE_SMA;
extern int    MaPeriod2         = 34;
extern int    MaPrice2          = PRICE_MEDIAN;
extern bool   HistogramOnSlope  = true;

extern bool   alertsOn          = true;
extern bool   alertsOnZeroCross = true;
extern bool   alertsOnSlope     = true;
extern bool   alertsOnCurrent   = false;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsNotify      = false;
extern bool   alertsEmail       = false;
extern string soundFile         = "alert2.wav";
//
//
//
//
//

double ao[];
double aohuu[];
double aohud[];
double aohdd[];
double aohdu[];
double slope[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);   
   SetIndexBuffer(0,aohuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,aohud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,aohdd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,aohdu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,ao);
   SetIndexBuffer(5,slope);
   SetIndexBuffer(6,trend);
   
   IndicatorShortName("Awesome 4 colors");
return(0);
}

//
//
//
//
//

int deinit()
{

return(0);
}

//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
       
   for(i=limit; i>=0; i--) ao[i] = iMA(NULL,0,MaPeriod1,0,MaMethod1,MaPrice1,i)-iMA(NULL,0,MaPeriod2,0,MaMethod2,MaPrice2,i);
   for(i=limit; i>=0; i--)
   {
      aohuu[i] = EMPTY_VALUE;
      aohud[i] = EMPTY_VALUE;
      aohdd[i] = EMPTY_VALUE;
      aohdu[i] = EMPTY_VALUE;
      slope[i] = slope[i+1];
      trend[i] = trend[i+1];
         if (ao[i] > 0)       trend[i] =  1;
         if (ao[i] < 0)       trend[i] = -1;
         if (ao[i] > ao[i+1]) slope[i] =  1;
         if (ao[i] < ao[i+1]) slope[i] = -1;
            
         if (HistogramOnSlope)
         {
           if (trend[i] ==  1 && slope[i] ==  1) aohuu[i] = ao[i];
           if (trend[i] ==  1 && slope[i] == -1) aohud[i] = ao[i];
           if (trend[i] == -1 && slope[i] == -1) aohdd[i] = ao[i];
           if (trend[i] == -1 && slope[i] ==  1) aohdu[i] = ao[i];
         }
         else
         {                  
           if (trend[i] ==  1) aohuu[i] = ao[i];
           if (trend[i] == -1) aohdd[i] = ao[i];
         }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;  

        //
        //
        //
        //
        //
            
        static datetime time1 = 0;
        static string   mess1 = "";
        if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar,"crossing zero up");
           if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar,"crossing zero down");
        }
      
        static datetime time2 = 0;
        static string   mess2 = "";
        if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar,"sloping up");
           if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar,"sloping down");
        }
    }    
   return(0);
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Awesome ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Awesome " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Awesome "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

